package cn.estsh.i3plus.core.api.iservice.busi;


import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;

import java.util.List;

/**
 * @Description : 系统功能业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 15:18:14.958
 * @Modify      :
 **/
public interface ISysMenuService {

    /**
     * 修改数据
     *
     * @param sysMenu
     */
    void updateSysMenu(SysMenu sysMenu);

    /**
     * 修改权限状态
     * @param id        修改权限状态
     * @param status    状态
     * @param user      当前会话用户
     * @return
     */
    void updateSysMenuStatus(long id, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     * @return
     */
    void deleteSysMenuById(long id);

    /**
     * 新增数据
     *
     * @param sysMenu
     * @return
     */
    SysMenu insertSysMenu(SysMenu sysMenu);

    /**
     * 查询所有数据
     *
     * @return
     */
    List<SysMenu> findSysMenuAll();

    /**
     * 根据id 数据
     *
     * @param id
     * @return
     */
    SysMenu getSysMenuById(long id);



}
