package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysRole;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Description : 系统角色业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.771
 * @Modify      :
 **/
public interface ISysRoleService {

    /**
     * 修改数据
     *
     * @param sysRole
     */
    void updateSysRole(SysRole sysRole);

    /**
     * 修改权限状态
     * @param id        修改权限状态
     * @param status    状态
     * @param user      当前用户会话
     * @return
     */
    void updateSysRoleStatus(long id, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     */
    void deleteSysRoleById(long id);

    /**
     * 新增数据
     *
     * @param sysRole
     * @return
     */
    SysRole insertSysRole(SysRole sysRole);

    /**
     * 查询所有数据
     *
     * @return
     */
    List<SysRole> findSysRoleAll();

    /**
     * 根据id 数据
     *
     * @param id
     * @return
     */
    SysRole getSysRoleById(long id);
}
