package cn.estsh.i3plus.core.apiservice.controller;

import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.quartz.ScheduleTool;
import cn.estsh.impp.framework.boot.quartz.TaskInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-26 10:34
 * @Modify:
 **/
@RestController
@RequestMapping("/schedule")
@Api(description="定时任务demo")
public class DemoScheduleController {
    private static final Logger LOGGER = LoggerFactory.getLogger(DemoScheduleController.class);

    /************ 定时任务demo *********/
    @Autowired
    private ScheduleTool scheduleTool;

    @GetMapping(value="/list-task")
    @ApiOperation(value="查询定时任务",notes="查询所有定时任务")
    public ResultBean listTask(){
        List<TaskInfo> taskList = scheduleTool.queryJobList();
        for(TaskInfo ti : taskList){
            System.out.println(ti);
        }

        return new ResultBean(true,"");
    }

    @GetMapping(value="/add-task")
    @ApiOperation(value="添加定时任务",notes="添加定时任务")
    public ResultBean addTask(String packageName,String className,String jobName,String jobGroup,String cronExpression){
        //String packageName = "cn.estsh.impp.framework.boot.quartz.job";
        //String className = "ImppJob";

        scheduleTool.addJob(new TaskInfo(packageName,className,jobName,jobGroup,cronExpression,"测试任务"));

        return new ResultBean(true,"");
    }

    @GetMapping(value="/delete-task")
    @ApiOperation(value="删除定时任务",notes="删除定时任务")
    public ResultBean deleteTask(String jobName,String jobGroup){
        scheduleTool.deleteJob(jobName,jobGroup);

        return new ResultBean(true,"");
    }

    @GetMapping(value="/pause-task")
    @ApiOperation(value="暂停定时任务",notes="暂停定时任务")
    public ResultBean pauseJob(String jobName,String jobGroup){
        scheduleTool.pauseJob(jobName,jobGroup);

        return new ResultBean(true,"");
    }

    @GetMapping(value="/resume-task")
    @ApiOperation(value="继续定时任务",notes="继续定时任务")
    public ResultBean resumeJob(String jobName,String jobGroup){
        scheduleTool.resumeJob(jobName,jobGroup);

        return new ResultBean(true,"");
    }

    @GetMapping(value="/exceute-task")
    @ApiOperation(value="立即执行定时任务",notes="立即执行定时任务")
    public ResultBean excuteJob(String jobName,String jobGroup){
        scheduleTool.executeJob(jobName,jobGroup);

        return new ResultBean(true,"");
    }

    @GetMapping(value="/stand-by-schedule")
    @ApiOperation(value="定时器待机",notes="定时器待机")
    public ResultBean restartJob(String jobName,String jobGroup){
        scheduleTool.standBySchedule();

        return new ResultBean(true,"");
    }


    @GetMapping(value="/start-schedule")
    @ApiOperation(value="启动定时器",notes="启动定时器")
    public ResultBean startSchedule(String jobName,String jobGroup){
        scheduleTool.startSchedule();

        return new ResultBean(true,"");
    }
}
