package cn.estsh.i3plus.core.apiservice.controller.base;

import cn.estsh.i3plus.core.api.iservice.base.IDataSimpleService;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.i3plus.pojo.mes.MachineFactory;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-05 16:40
 * @Modify:
 **/
@RestController
@RequestMapping("/simple-service")
@Api(tags="SimpleController",description="简单服务demo")
public class SimpleController {
    private Logger LOGGER = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private IDataSimpleService dataSimpleService;

    @PutMapping(value="/insert")
    @ApiOperation(value="service服务",notes="返回内容添加service")
    public ResultBean insertFactory(@RequestParam("name")String name, @RequestParam("code")String code){
        MachineFactory machineFactory = new MachineFactory();
        machineFactory.setFactoryName(name);
        machineFactory.setFactoryCode(code);
        dataSimpleService.saveMachineFactory(machineFactory);

        return new ResultBean(true,"工厂已保存");
    }

    @GetMapping(value = "/find-by-factory-name")
    @ApiOperation(value="查询工厂",notes="通过工厂名称查询工厂")
    public ResultBean findMachineFactoryByFactoryName(String factoryName){
        List<MachineFactory> factoryList = dataSimpleService.findMachineFactoryByFactoryName(factoryName);

        return new ResultBean(true,factoryList);
    }

    @GetMapping(value = "/find-by-factory-code")
    @ApiOperation(value="查询工厂",notes="通过工厂代码查询工厂")
    public ResultBean findMachineFactoryByFactoryCode(String factoryCode){
        List<MachineFactory> factoryList = dataSimpleService.findMachineFactoryByFactoryCode(factoryCode);

        return new ResultBean(true,factoryList);
    }

    @GetMapping(value = "/find-by-factory-special")
    @ApiOperation(value="特殊查询",notes="通过工厂代码查询工厂")
    public ResultBean findMachineFactorySpecial(){
        List<MachineFactory> factoryList = dataSimpleService.findMachineFactorySpecial();

        return new ResultBean(true,factoryList);
    }

    @PutMapping(value="/update")
    @ApiOperation(value="service服务",notes="返回内容添加service")
    public ResultBean updateFactory(long id, String name){
        dataSimpleService.updateMachineFactoryNameById(id,name);

        return new ResultBean(true,"工厂已修改");
    }

    @DeleteMapping(value="/delete")
    @ApiOperation(value="service服务",notes="返回内容添加service")
    public ResultBean deleteMachineFactoryById(long id){
        dataSimpleService.deleteMachineFactoryById(id);

        return new ResultBean(true,"工厂已删除");
    }
}
