package cn.estsh.i3plus.core.apiservice.controller.busi;

import cn.estsh.i3plus.core.api.iservice.busi.IOrganizeService;
import cn.estsh.i3plus.pojo.platform.bean.Organize;
import cn.estsh.i3plus.pojo.platform.bean.SysUser;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Description : 组织对外接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:42.972
 * @Modify      :
 **/
@RestController
@RequestMapping("/organize") 
@Api(description = "组织")
public class OrganizeController {

    public static final Logger LOGGER = LoggerFactory.getLogger(OrganizeController.class);

    public static SysUser USER;

    static {
        USER =new SysUser();
        USER.setEmployeeNameRdd("中国移动");
        USER.setId(10086L);
    }


    @Autowired
    private IOrganizeService organizeService;

    @PostMapping(value = "/insert")
    @ApiOperation(value = "新增组织", notes = "组织")
    public ResultBean insertOrganize(Organize organize) {
        organizeService.insertOrganize(organize);
        return new ResultBean(true, "操作成功", organize);
    }

    @PutMapping(value = "/update")
    @ApiOperation(value = "修改组织", notes = "组织")
    public ResultBean updateOrganize(Organize organize) {
        organizeService.updateOrganize(organize);
        return new ResultBean(true, "操作成功", organize);
    }

    @DeleteMapping(value = "/delete")
    @ApiOperation(value = "删除组织", notes = "删除组织")
    public ResultBean deleteOrganize(Long id) {
        organizeService.deleteOrganizeById(id,USER.getEmployeeNameRdd());
        return new ResultBean(true, "操作成功");
    }

    @GetMapping(value = "/findOrganizeAll")
    @ApiOperation(value = "查询Organize", notes = "查询所有组织")
    public ResultBean findOrganizeAll() {
        List<Organize> list = organizeService.findOrganizeAll();
        return new ResultBean(true, "操作成功", list);
    }

    @GetMapping(value = "/getOrganize/{id}")
    @ApiOperation(value = "查询组织", notes = "查询根据ID查询组织")
    public ResultBean getByOrganizeId(@PathVariable("id") long id) {
        Organize organize = organizeService.getOrganizeById(id);
        return new ResultBean(true, "操作成功", organize);
    }
}
