package cn.estsh.i3plus.core.apiservice.mq;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Description : wms队列
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-26 16:57
 * @Modify:
 **/
@Configuration
public class I3CoreQueue {
    private static final Logger LOGGER = LoggerFactory.getLogger(I3CoreQueue.class);

    public static final String DEMO_STR_QUEUE = "demo_str_queue";

    public static final String DEMO_OBJ_QUEUE = "demo_obj_queue";

    public static final String DEMO_HANDLE_QUEUE = "demo_handle_queue";

    public static final String DEMO_ACK_QUEUE = "ack_queue";

    public static final String DEMO_RETURN_QUEUE = "return_queue";

    @Bean
    public Queue getStrQueue() {
        //LOGGER.info("【DEMO_STR_QUEUE队列】");
        return new Queue(DEMO_STR_QUEUE);
    }

    @Bean
    public Queue getObjQueue() throws Exception {
        //LOGGER.info("【DEMO_OBJ_QUEUE队列】");
        return new Queue(DEMO_OBJ_QUEUE);
    }

    @Bean
    public Queue getHandleQueue() throws Exception {
        //LOGGER.info("【DEMO_HANDLE_QUEUE队列】");
        return new Queue(DEMO_HANDLE_QUEUE);
    }

    @Bean
    public Queue getReturnQueue() throws Exception {
        //LOGGER.info("【DEMO_RETURN_QUEUE队列】");
        return new Queue(DEMO_RETURN_QUEUE);
    }

    @Bean
    public Queue getAckQueue() throws Exception {
        LOGGER.info("【DEMO_ACK_QUEUE队列】");
        return new Queue(DEMO_ACK_QUEUE);
    }
}
