package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.IOrganizeService;
import cn.estsh.i3plus.pojo.base.enumutil.ImppEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.Organize;
import cn.estsh.i3plus.pojo.platform.repository.OrganizeRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 组织业务接口实现 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:42.957
 * @Modify      :
 **/
@Service
public class OrganizeServiceImpl implements IOrganizeService {

    public static final Logger LOGGER = LoggerFactory.getLogger(OrganizeServiceImpl.class);

    @Autowired
    private OrganizeRepository organizeRepository;

    @Override
    public void updateOrganize(Organize organize) {
        LOGGER.info("组织 ORGANIZE :{}", organize);
        organizeRepository.update(organize);
    }

    @Override
    public void deleteOrganizeById(long id,String modifyUser) {
        LOGGER.info("组织 ORGANIZE Key:{}", id);
        //TODO 记录平台用户操作日志
        organizeRepository.deleteById(id);
    }

    @Override
    public Organize insertOrganize(Organize organize) {
        LOGGER.info("组织 ORGANIZE :{}", organize);
        if(null != organize.getOrganizationTypeId()){
            organize.setOrganizationTypeName(ImppEnumUtil.ORGANIZE_YTPE.valueOfCode(organize.getOrganizationTypeId()));
        }
        return organizeRepository.insert(organize);
    }

    @Override
    public List<Organize> findOrganizeAll() {
        LOGGER.info("组织 ORGANIZE find All");
        return organizeRepository.findAll();
    }

    @Override
    public Organize getOrganizeById(long id) {
        LOGGER.info("组织 ORGANIZE find id:{}", id);
        return organizeRepository.getOne(id);
    }
}
